/*  BVI.H
 *
 *  NOTE: Edit this file with tabstop=4 !
 *
 * Copyright 1996 by Gerhard Buergmann (G.Buergmann@nl.cis.philips.com)
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * See file COPYING for information on distribution conditions.
 */


#define HEX			0
#define ASCII		1
#define FORWARD		0
#define BACKWARD	1
#define EDIT		1
#define TRUNC		2
#define CR			'\r'
#define NL			'\n'
#define BS			8
#define	ESC			27
#define SEARCH		0
#define REPLACE		1
#ifndef CTRL	
#	define CTRL(n)		n&0x1f
#endif

#ifndef NULL
#	define NULL		((void *)0)
#endif

#ifndef TRUE
#	define TRUE		1
#	define FALSE	0
#endif

#ifdef __MSDOS__
#	define ANSI
#	define PTR		char huge *
#   define DELIM	'\\'
#   define  strncasecmp strnicmp
#   define  strcasecmp	stricmp
#else
#	define PTR		char *
#   define DELIM	'/'
#endif

#define MAXCMD	255
#define BUFFER	1000

extern	char	*version;
extern	char	*sys_errlist[];
extern	int		maxx, maxy, x, y;
extern	int		loc;
extern	int		edits, new;
extern	PTR		mem;
extern	PTR		maxpos;
extern	PTR		pagepos;
extern	PTR		undo_start;
extern	PTR		current_start;
extern  PTR		curpos;
extern	PTR		current;
extern	char	*name;
extern	long	filesize, memsize;
extern	int		Anzahl;
extern	PTR		markbuf[];
extern  PTR		last_motion;
extern	int		undo_count;
extern	long	undosize;
extern	char	undo_buf[BUFFER];
extern	int		repl_count;
extern	char	string[];
extern	char	*shell;



#ifdef ANSI
	void	do_exit(void), do_shell(void);
	void	badcmd(char *);
	void	docmdline(char *);
	int		doecmd(char *s, int i);
	int		regexec(PTR, char *);
	PTR		wordsearch(PTR, char);
	PTR		backsearch(PTR, char);
	PTR		fsearch(PTR, PTR);
	PTR		rsearch(PTR, PTR);
	PTR		end_word(PTR);
	char	*patcpy(char *, char *, char);
	void	setpage(PTR), msg(char *), emsg(char *), smsg(char *);
	void	wait_return(void);
	void	usage(void), bvi_init(char *), statpos(void), setcur(void);
	void	toggle(void), scrolldown(int), scrollup(int);
	void	cur_forw(void), cur_back(void), fileinfo(char *);
	void	clearstr(void), clear_marks(void), repaint(void), new_screen(void);
	void	quit(void), sysemsg(char *), do_z(int), stuffin(char *);
	long	load(char *);
	int		lineout(void), save(char *), at_least(char *, char *, int);
	int		edit(int), vgetc(void), xpos(void), enlarge(long);
	int		searching(int, char *, int), getcmdstr(char *, int), read_rc(char *);
#else
	void	do_exit(), do_shell();
	void	badcmd();
	void	docmdline();
	int		doecmd();
	PTR		wordsearch();
	PTR		backsearch();
	int		regexec();
	PTR		fsearch();
	PTR		rsearch();
	PTR		end_word();
	char	*patcpy();
	void	setpage(), msg(), emsg(), smsg(), wait_return();
	void	usage(), bvi_init(), statpos(), setcur();
	void	toggle(), scrolldown(), scrollup();
	void	cur_forw(), cur_back(), fileinfo();
	void	clearstr(), clear_marks(), new_screen(), repaint();
	void	quit(), sysemsg(), do_z(), stuffin();
	long	load();
	int		lineout(), save(), at_least(), read_rc();
	int		searching(), getcmdstr(), enlarge();
	int		edit(), vgetc(), xpos();
#endif
