/* SET.H
 *
 * NOTE: Edit this file with tabstop=4 !
 *
 * Copyright 1996 by Gerhard Buergmann (G.Buergmann@nl.cis.philips.com)
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * See file COPYING for information on distribution conditions.
 */

struct	param {
	char	*fullname;	/* full parameter name */
	char	*shortname;	/* permissible abbreviation */
	int	value;		/* parameter value */
	int	flags;
};

extern	struct	param	params[];
extern	int	maxy;

#define	P_BOOL		0x01	/* the parameter is boolean */
#define	P_NUM		0x02	/* the parameter is numeric */
#define P_TEXT		0x04	/* the paameter is text */
#define	P_CHANGED	0x08	/* the parameter has been changed */

/*
 * The following are the indices in the params array for each parameter
 */

/*
 * Numeric parameters
 */
#define	P_SS		0	/* scroll size */
#define	P_LI		1	/* lines */
#define	P_OF		2	/* address offset */
/*
 * Boolean parameters
 */
#define	P_WS		3	/* wrapscan */
#define	P_EB		4	/* error bells */
#define	P_MO		5	/* show mode */
#define	P_IC		6	/* ignore case in searches */
#define	P_MA		7	/* Magic characters in reg expr */
#define P_WL		8	/* Wordlength for w, W, b, B command */
#define	P_AW		9	/* Autowrite */
#define P_RO		10	/* Readonly */
#define P_US		11	/* Unix-Style of ASCII representation */
#define P_TE		12	/* Terse (short messages) */
#define	P_CO		13	/* color/attribute setting */

/*
 * Macro to get the value of a parameter
 */
#define	P(n)	(params[n].value)
